From 1214c098940f16815c8eb2655fd7660a87b4e8ee Mon Sep 17 00:00:00 2001
From: "Robert A. Burks" <rburksdev@gmail.com>
Date: Thu, 14 Mar 2024 22:01:39 -0400
Subject: [PATCH 09/31] ; * src/data.c (set_internal): Avoid using enumeration
 as boolean

Added commentary acknowledging this is proper thread switching behavior.
---
 src/data.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

diff --git a/src/data.c b/src/data.c
index 678335759f0..c5ea7e6a80c 100644
--- a/src/data.c
+++ b/src/data.c
@@ -1709,8 +1709,11 @@ set_internal (Lisp_Object symbol, Lisp_Object newval, Lisp_Object where,
 		   make CURRENT-ALIST-ELEMENT point to itself,
 		   indicating that we're seeing the default value.
 		   Likewise if the variable has been let-bound
-		   in the current buffer.  */
-		if (bindflag || !blv->local_if_set
+		   in the current buffer.
+		   Likewise if we are setting the variable due to
+		   thread switching.  */
+		if (bindflag != SET_INTERNAL_SET
+		    || !blv->local_if_set
 		    || let_shadows_buffer_binding_p (sym))
 		  {
 		    blv->found = false;
-- 
2.34.1

